<template>
  <el-dialog
    append-to-body
    :title="textMap[dialogStatus]"
    :visible.sync="dialogFormVisible"
  >
    <el-form
      ref="dataForm"
      :rules="rules"
      :model="deviceForm"
      label-width="100px"
      label-well-code="right"
    >
      <el-row :gutter="20">
        <el-col :span="12">
          <el-form-item label="设备类型" prop="deviceType">
            <el-select
              v-model="deviceForm.deviceType"
              placeholder="请选择设备类型"
              clearable
              :disabled="dialogStatus === 'create' ? false : true"
            >
              <el-option
                v-for="item in deviceTypeList"
                :key="item.value"
                :label="item.name"
                :value="item.value"
              />
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="型号名称" prop="modelName">
            <el-input
              v-model.trim="deviceForm.modelName"
              type="text"
              :disabled="dialogStatus === 'create' ? false : true"
              clearable
              placeholder="请输入型号名称"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="24">
        <el-col :span="12">
          <el-form-item label="通信方式" prop="communication">
            <el-select
              v-model="deviceForm.communication"
              clearable
              multiple
              placeholder="请选择通信方式"
              :disabled="dialogStatus === 'detail' ? true : false"
            >
              <el-option
                v-for="item in commuList"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              />
            </el-select>
          </el-form-item>
        </el-col>
        <el-col v-show="dialogStatus === 'detail' ? true : false" :span="12">
          <el-form-item label="设备编号" prop="devcode">
            <el-input
              v-model.trim="deviceForm.devcode"
              type="text"
              clearable
              devcode
              disabled
            />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <div
      v-show="dialogStatus === 'detail' ? false : true"
      slot="footer"
      class="dialog-footer"
    >
      <el-button type="primary" @click="saveData">
        保存
      </el-button>
      <el-button @click="dialogFormVisible = false">
        取消
      </el-button>
    </div>
  </el-dialog>
</template>

<script>
import { getDevice, updateDeviceModel, addDeviceModel } from '@/api/device/deviceModel'
export default {
  name: 'EditDeviceModel',
  data() {
    return {
      dialogFormVisible: false, // 对话框显示隐藏
      dialogStatus: '', // 对话框类型：create,update,detail
      deviceTypeList: [],
      // 对话框标题
      textMap: {
        update: '编辑',
        create: '新增',
        detail: '详情'
      },
      commuList: [
        {
          label: 'LORA',
          value: '0'
        },
        {
          label: '3G',
          value: '1'
        },
        {
          label: '4G',
          value: '2'
        },
        {
          label: '联通移动NB',
          value: '3'
        },
        {
          label: '电信NB',
          value: '4'
        }
      ],
      // 表单内容
      deviceForm: {
        modelName: '',
        deviceType: '',
        communication: [],
        devcode: ''
      },
      // 表单校验规则
      rules: {
        modelName: [{ required: true, message: '型号名称必填', trigger: ['blur', 'change'] }],
        deviceType: [{ required: true, message: '设备主键必填', trigger: ['blur', 'change'] }],
        communication: [{ required: true, message: '通讯方式必选', trigger: ['blur', 'change'] }]
      }
    }
  },
  created() {
    this.fetchDeviceType()
  },
  methods: {
    // 获取设备类型
    fetchDeviceType() {
      getDevice(this.listQuery).then(response => {
        this.deviceTypeList = response.data
      })
    },
    // 重置表单
    resetForm() {
      this.deviceForm = {
        modelName: '',
        deviceType: '',
        communication: '',
        devcode: ''
      }
    },
    // 父子组件通信
    initDialog(dialogStatus, row = null) {
      console.log(row, '====21==')
      this.dialogFormVisible = true
      this.dialogStatus = dialogStatus
      if (this.dialogStatus === 'create') {
        this.resetForm()
        this.$nextTick(() => {
          this.$refs['dataForm'].clearValidate()
        })
      } else if (this.dialogStatus === 'update' || this.dialogStatus === 'detail') {
        console.log(row)
        this.deviceForm = {
          modelName: row.deviceTypeName,
          deviceType: row.modelName,
          communication: row.communication.split(','),
          devcode: row.id
        }
      }
    },
    // 保存数据
    saveData() {
      if (this.dialogStatus === 'update') {
        this.updateData()
      } else if (this.dialogStatus === 'create') {
        this.createData()
      }
    },
    // 修改数据
    updateData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          this.deviceForm.communication = this.deviceForm.communication.toString()
          updateDeviceModel(this.deviceForm).then(response => {
            if (response.code === 200) {
              this.$message.success('修改成功')
              this.$emit('watchChild')
              this.dialogFormVisible = false
            }
          })
        }
      })
    },
    // 新增数据
    createData: function() {
      this.$refs['dataForm'].validate((valid) => {
        console.log(this.deviceForm)
        if (valid) {
          this.deviceForm.communication = this.deviceForm.communication.toString()
          addDeviceModel(this.deviceForm).then(response => {
            if (response.code === 200) {
              this.$confirm('新增成功，是否继续新增?', '提示', {
                confirmButtonText: '是',
                cancelButtonText: '否',
                type: 'info'
              }).then(() => {
                this.resetForm()
                this.$nextTick(() => {
                  this.$refs['dataForm'].clearValidate()
                })
              }).catch(() => {
                this.$emit('watchChild') // 刷新父组件数据列表
                this.dialogFormVisible = false
              })
            }
          })
        }
      })
    }
  }
}
</script>

